<?php
$set['script']     = $_SERVER['PHP_SELF'];
$set['Title']      = "cineteca Film";
$set['FirstField'] = "onload='document.filmForm.movie_title.focus()'";
$set['log']        = false;
$set['mySql']      = true;

if($set['log']) error_log("script      : ***** ".$set['script'], 0);
if($set['log']) error_log("bottone     : ".(empty($_POST['submit']) ? '' : $_POST['submit']), 0);

require_once 'cineteca.include';

/* ---------------------------------------------------------------- */

$set['todo'] = "form"; 
$message     = "";

if ( empty($_POST) or $_POST['submit'] == "rinuncia" )
{
    inizializzaVariabili();
}
else
{
    leggiPost();

    validaForm();

    if  ( empty($message)
    and   in_array( $set['azione'], 
                    array("cerca", "conferma", "conferma ins", "conferma mod", "conferma elim") ) )
    {
        aggiornaDB($set['azione']);
    }
}
if ( $set['todo'] == "list" ) displayFilmList();
else                          displayForm($set['azione']);
die;

/* ---------------------------------------------------------------- */

function inizializzaVariabili()
{
    global $conn, $set, $row;

    if($set['log']) error_log("inizializzaVariabili", 0);

    $set['azione']       = "";

    $row['film_id']      = "";
    $row['movie_title']  = "";
    $row['also_known']   = "";
    $row['year']         = "";
    $row['minutes']      = "";
    $row['distributor']  = "";
    $row['studio']       = "";
    $row['release_data'] = "";
    $row['incollection'] = "0";
    $row['synopsis']     = "";
}

/* ---------------------------------------------------------------- */

function leggiPost()
{
    global $conn, $set, $row;

    $set['azione']       = trim(htmlspecialchars($_POST['submit']));

    if($set['log']) error_log("leggiPost   : ".$set['azione'], 0);

    if ( $set['azione'] == "conferma" )
    {
        $row['film_id']      = trim(htmlspecialchars($_POST['rowid']));
    }
    else
    {
        $row['film_id']      = trim(htmlspecialchars($_POST['film_id']));
        $row['movie_title']  = trim(htmlspecialchars($_POST['movie_title']));
        $row['also_known']   = trim(htmlspecialchars($_POST['also_known']));
        $row['year']         = trim(htmlspecialchars($_POST['year']));
        $row['minutes']      = trim(htmlspecialchars($_POST['minutes']));
        $row['distributor']  = trim(htmlspecialchars($_POST['distributor']));
        $row['studio']       = trim(htmlspecialchars($_POST['studio']));
        $row['release_data'] = trim(htmlspecialchars($_POST['release_data']));
        $row['incollection'] = trim(htmlspecialchars($_POST['incollection']));
        $row['synopsis']     = trim(htmlspecialchars($_POST['synopsis']));
    }
}

/* ---------------------------------------------------------------- */

function validaForm()
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("validaForm  : ".$set['azione'], 0);

    // qui vanno fatti i controlli dei dati inseriti

    if( !in_array( $set['azione'], 
                   array("inserisci", "cerca", "conferma", "modifica", "elimina", "conferma ins", "conferma mod", "conferma elim") ) ) 
    {
        $message = "ERRORE : validaForm, non riconosco l&acute; azione da compiere";
        return;
    }

    if( in_array( $set['azione'], 
                  array("conferma") ) )
    {
        if( empty($row['film_id']) )
        {
            $set['azione'] = "";
            $message = "ERRORE : non hai fatto nessuna scelta";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("modifica", "elimina", "conferma mod", "conferma elim") ) )
    {
        if( empty($row['film_id']) )
        {
            $set['azione'] = "";
            $message = "ERRORE : devi indicare il film ID";
            return;
        }
        if( empty(aggiornaDB("conta_id")) )
        {
            $set['azione'] = "";
            $message = "ERRORE : non ho trovato nessun elemento con l&acute; ID indicato";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("elimina") ) )
    {
        if( !empty(aggiornaDB("conta_colleg")) )
        {
            inizializzaVariabili();
            $message = "ERRORE : esistono attori collegati, il film non puo&grave; essere eliminato dal DB";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("inserisci", "conferma ins") ) )
    {
        if( !empty($row['film_id']) )
        {
            $set['azione'] = "";
            $message = "ERRORE : nella fase di inserimento l&acute; ID non deve essere presente";
            return;
        }
        if( !empty(aggiornaDB("conta_titolo")) )
        {
            $set['azione'] = "";
            $message = "ERRORE : stai tentando di inserire un titolo che esiste gi&agrave;";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("inserisci", "conferma ins", "modifica", "conferma mod") ) )
    {
//      QUI DEVE ESSERE CONTROLLATA LA PRESENZA E CONGRUITA' DEI DATI INSERITI
    }
}

/* ---------------------------------------------------------------- */

function aggiornaDB($azione = "")
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("aggiornaDB  : ".$azione, 0);

    switch ($azione)
    {
        case "conferma ins":
            $sql = "INSERT INTO film(movie_title, also_known, year, minutes, distributor, studio, release_data, incollection, synopsis) VALUES ("
                 . "  '" . $row['movie_title']  . "'"
                 . ", '" . $row['also_known']   . "'"
                 . ", '" . $row['year']         . "'"
                 . ", '" . $row['minutes']      . "'"
                 . ", '" . $row['distributor']  . "'"
                 . ", '" . $row['studio']       . "'"
                 . ", '" . $row['release_data'] . "'"
                 . ", '" . $row['incollection'] . "'"
                 . ", '" . $row['synopsis']     . "'"
                 . "  )";
            $x = "inserito";
            break;

        case "conferma mod":
            $sql = "UPDATE film SET"
                 . "  movie_title='"   . $row['movie_title']  . "'"
                 . ", also_known='"    . $row['also_known']   . "'"
                 . ", year='"          . $row['year']         . "'"
                 . ", minutes='"       . $row['minutes']      . "'"
                 . ", distributor='"   . $row['distributor']  . "'"
                 . ", studio='"        . $row['studio']       . "'"
                 . ", release_data='"  . $row['release_data'] . "'"
                 . ", incollection='"  . $row['incollection'] . "'"
                 . ", synopsis='"      . $row['synopsis']     . "'"
                 . "  WHERE film_id='" . $row['film_id']      . "'";
            $x = "modificato";
            break;

        case "conferma elim":
            $sql = "DELETE FROM film"
                 . " WHERE film_id='" . $row['film_id']. "'";
            $x = "eliminato";
            break;

        case "cerca":
        case "conferma":
            if( !empty($row['film_id']) )
            {
                $sql = "SELECT film_id, movie_title, also_known, year, minutes, distributor, studio, release_data, incollection, synopsis"
                     . " FROM film WHERE film_id='" . $row['film_id'] . "'";
            }
            else
            {
                $sql = "SELECT film_id, movie_title, also_known, year, minutes, distributor, studio, release_data, incollection, synopsis"
                     . " FROM film WHERE 1=1";
                if ($row['film_id'])      { $sql.= " and film_id="             . $row['film_id']; }
                if ($row['movie_title'])  { $sql.= " and movie_title like '%"  . $row['movie_title']."%'"; }
                if ($row['also_known'])   { $sql.= " and also_known like '%"   . $row['also_known']."%'"; }
                if ($row['year'])         { $sql.= " and year like '%"         . $row['year']."%'"; }
                if ($row['minutes'])      { $sql.= " and minutes like '%"      . $row['minutes']."%'"; }
                if ($row['distributor'])  { $sql.= " and distributor like '%"  . $row['distributor']."%'"; }
                if ($row['studio'])       { $sql.= " and studio like '%"       . $row['studio']."%'"; }
                if ($row['release_data']) { $sql.= " and release_data like '%" . $row['release_data']."%'"; }
                if ($row['incollection']) { $sql.= " and incollection like '%" . $row['incollection']."%'"; }
                if ($row['synopsis'])     { $sql.= " and synopsis like '%"     . $row['synopsis']."%'"; }
                $sql.= " ORDER BY movie_title, distributor, year";
            }
            break;

        case "conta_id":
            $sql = "SELECT count(*) as counter FROM film WHERE film_id='" . $row['film_id'] . "'";
            break;

        case "conta_titolo":
            $sql = "SELECT count(*) as counter FROM film WHERE movie_title='" . $row['movie_title'] . "'";
            break;

        case "conta_colleg":
            $sql = "SELECT count(*) as counter FROM film_actor WHERE film_id=" . $row['film_id'];
            break;

        default:
            $message = "ERRORE : aggiornaDB, non riconosco l&acute; azione da compiere";
            return;
            break;
    }



    if($set['log']) error_log("sql         : ".$sql, 0);

    $result = $conn->query($sql);
    if ( !$result ) { $message = "ERRORE : aggiornaDB, errore nella query, " . $conn->error; return; }



    switch ($azione)
    {
        case "cerca":
        case "conferma":
            if($set['mySql']) { $dati = $result->fetch_all(MYSQLI_ASSOC);  $result->free(); }
            else              { $dati = $conn->queryS($sql); }

            if( count($dati) == 1 ) { $row = $dati[0]; $set['todo'] = "form"; } else
            if( count($dati) > 1 )  { $row = $dati;    $set['todo'] = "list"; } else
            {
                $message = "ERRORE : aggiornaDB, non ho trovato elementi per la ricerca fatta";
                $set['azione'] = "";
            }
            break;

        case "conta_id":
        case "conta_titolo":
        case "conta_colleg":
            if($set['mySql']) { $dati = $result->fetch_assoc();  $result->free(); }
            else              { $dati = $result->fetch(); }

            return $dati['counter'];
            break;

        default:
            $message = "Congratulazioni, ".$row['movie_title']." (".$row['year'].") é stato ".$x." nel database.";
            inizializzaVariabili();
            break;
    }
}

/* ---------------------------------------------------------------- */

function displayForm($azione = "")
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("displayForm : ".$azione, 0);
    if($set['log']) error_log("errore      : ".$message, 0);

    // gestisci bottoni
    $readonly1 = " readonly";
    $readonly2 = " readonly";

    switch ($azione)
    {
        case "cerca":
        case "conferma":
            $readonly2 = "";
            $btn = "<input type='submit' name='submit' value='modifica' />"
                 . "<span style='padding-left: 30px;'></span>"
                 . "<input type='submit' name='submit' value='elimina' />";
            break;

        case "inserisci":
            $btn = "<input type='submit' name='submit' value='conferma ins' />";
            break;

        case "modifica":
            $btn = "<input type='submit' name='submit' value='conferma mod' />";
            break;

        case "elimina":
            $btn = "<input type='submit' name='submit' value='conferma elim' />";
            break;

        default:
            $readonly1 = "";
            $readonly2 = "";
            $btn = "<input type='submit' name='submit' value='inserisci' />"
                 . "<span style='padding-left: 30px;'></span>"
                 . "<input type='submit' name='submit' value='cerca' />";
            break;
    }
    $btn .= "<span style='padding-left: 30px;'></span>"
         .  "<input type='submit' name='submit' value='rinuncia' />";


    // valorizza la select "incollection"
    $opt = "";
    $incollection = array( 0 => 'scegli uno stato', 1 => 'Yes', 2 => 'No' );  // possible options for in collection
    for( $i=0; $i < count($incollection); $i++ )
    {
        $selected = $i == $row['incollection'] ? ' selected' : '';
        $opt .= "<option" . $selected . " value='" . $i . "'>" . $incollection[$i] . "</option>";
    }
?>
<!DOCTYPE html>
<html>
  <head>
    <meta charset='utf-8'>
    <meta http-equiv='X-UA-Compatible' content='IE=edge'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>

    <title><?= $set['Title']; ?></title>
  </head>
  <body <?= $set['FirstField']; ?>>

<div class='form-group'>

  <center><h1><span class='infoblock-pagetype'>cineteca Film</span></h1></center>

  <form name='filmForm' method='POST' action='<?= $set['script']; ?>'>

    <table id='biographyTable' border='0' cellspacing='0' cellpadding='0' width='100%'>
      <tbody>
        <tr>
          <td class='paramname'>
            <b>film ID:</b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='film_id' id='film_id' size='15' value='<?= $row['film_id']; ?>'<?= $readonly1; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Title:</b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='movie_title' id='movie_title' size='100' value='<?= $row['movie_title']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Also Known As:</b>
          </td>
          <td class='paramvalue'>
            <textarea name='also_known' id='also_known' rows='5' cols='80'<?= $readonly2; ?>><?= $row['also_known']; ?></textarea>
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Year: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='year' id='year' size='15' value='<?= $row['year']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Minutes: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='minutes' id='minutes' size='15' value='<?= $row['minutes']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Distributor: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='distributor' id='distributor' size='100' value='<?= $row['distributor']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Studio: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='studio' id='studio' size='100' value='<?= $row['studio']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Release Date: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='release_data' id='release_data' size='15' value='<?= $row['release_data']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>In Collection: </b> (<b><font color='red'>selezionare il valore</font></b>)
          </td>
          <td class='paramvalue'>
            <select name='incollection', id='incollection'><?= $opt; ?></select>
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Synopsis: </b>
          </td>
          <td class='paramvalue'>
            <textarea name='synopsis' id='editor1' rows='10' cols='80'<?= $readonly2; ?>><?= $row['synopsis']; ?></textarea>
          </td>
        </tr>
        <tr>
          <td class='paramvalue-footer center' colspan='2'>
            <br />

            <?= $btn; ?>

            <br />
            <br />
          </td>
        </tr>
      </tbody>
    </table>
  </form>
  <div class='col-sm-10 col-sm-offset-2'><h2><?= $message; ?></h2></div>
</div>

<script src="https://cdn.ckeditor.com/ckeditor5/18.0.0/classic/ckeditor.js"></script>
<script> CKEDITOR.replace('editor1', { extraPlugins: 'colorbutton,colordialog' });</script>

</body>
</html>
<?php
}

/* ---------------------------------------------------------------- */

function displayFilmList()
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("displayFilmList", 0);
    if($set['log']) error_log("errore             : ".$message, 0);
?>
<!DOCTYPE html>
<html>
  <head>
    <meta charset='utf-8'>
    <meta http-equiv='X-UA-Compatible' content='IE=edge'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>

    <title><?= $set['Title']; ?></title>
  </head>
  <body>

<div class='form-group'>

  <center><h1><span class='infoblock-pagetype'>cineteca scelta Film</span></h1></center>

  <form name='FilmList' method='POST' action='<?= $set['script']; ?>'>

    <table id='biographyTable' border='0' cellspacing='0' cellpadding='0' width='100%'>
      <thead>
        <tr>
          <td class='paramname'><b>Seleziona</b></td>
          <td class='paramname'><b>film ID</b></td>
          <td class='paramname'><b>Title</b></td>
          <td class='paramname'><b>Year</b></td>
          <td class='paramname'><b>Distributor</b></td>
          <td class='paramname'><b>Release Date</b></td>
        </tr>
      </thead>
      <tbody>
<?php for($x=0; $x<count($row); $x++) { ?>
        <tr>
          <td class='paramvalue'><input type='radio' name='rowid' value='<?= $row[$x]['film_id']; ?>'></td>
          <td class='paramvalue'><?= $row[$x]['film_id']; ?></td>
          <td class='paramvalue'><?= $row[$x]['movie_title']; ?></td>
          <td class='paramvalue'><?= $row[$x]['year']; ?></td>
          <td class='paramvalue'><?= $row[$x]['distributor']; ?></td>
          <td class='paramvalue'><?= $row[$x]['release_data']; ?></td>
        </tr>
<?php } ?>
        <tr>
          <td class='paramvalue-footer center' colspan='2'>
            <br />

            <input type='submit' name='submit' value='conferma' />
            <span style='padding-left: 30px;'></span>
            <input type='submit' name='submit' value='rinuncia' />

            <br />
            <br />
          </td>
        </tr>
      </tbody>
    </table>
  </form>
  <div class='col-sm-10 col-sm-offset-2'><h2><?= $message; ?></h2></div>
</div>
</body>
</html>
<?php
}
?>
